/*
Script to test stored procedures
*/

-- Declarations
DECLARE @Result int
DECLARE @Result1 int
DECLARE @Result2 int
DECLARE @Result3 int

-- No counting 
SET NOCOUNT ON

-- Build random bipartite graph with selected number of left nodes
-- and probability for edge creation.
-- Disable this section if you've built your own bipartite graph
EXEC @Result = spBuildBipartite 10, 0.25
IF @Result <> 1 RETURN 
 
-- Check that graph is bipartite 
-- This is only required if a manually created graph is used 
-- Enable this section if you've built your own bipartite graph
-- EXEC @Result = spCheckBipartite 
-- IF @Result <> 1 RETURN

--Apply greedy algorithm to get partial matching
EXEC @Result = spGreedy 
IF @Result <> 1 RETURN   
 
-- Initialize U, V, S, T, Path
EXEC @Result = spInitializeS
--IF @Result = 0 RETURN
 
-- Attempt to find perfect matching
-- For each loop, at least one of M or S will expand or no perfect match exists
WHILE 1 = 1
	BEGIN

	-- Repeatedly expand M with a new edge until it fails 
	-- Whenever successful: U, V, S, T, Path must be re-initialized
	SET @Result1 = 1
	SET @Result2 = 1
	WHILE @Result1 = 1
	BEGIN
   		EXEC @Result1 = spExpandM	
		IF @Result1 = 1 
			BEGIN
				EXEC @Result2 = spInitializeS 
				IF @Result2 = 0 RETURN  -- spExpandM may have just built a perfect match
			END
	END

	-- Expand S
	-- Expanding M has just failed so if expanding S fails, no perfect matching exists
	-- If expanding S succeeds, try expanding M again 
 	EXEC @Result3 = spExpandS
	IF @Result3 <> 1 RETURN
	
	END





	  